#include <stdlib.h>
#include <stdio.h>
#define I2C_CLK 133332000
//#define I2C_CLK 533332000

int main(int argc, char *argv[])
{
  unsigned long A,B,C;
  unsigned long Ga,Gb;
  unsigned long divisor, req_div;
  unsigned long est_div, est_FDR, est_A, est_B;
  unsigned long bin_Gb, bin_Ga;
  unsigned long speed;

  if (argc != 2) {
    printf("%s <speed in HZ>\n", argv[0]);
    exit(1);
  }
  speed = atol(argv[1]);
  req_div = I2C_CLK/speed;
  C = (5*(I2C_CLK/1000))/(100000);
  if (!C)
    C = 1;

  est_div = ~0;
  for(Ga=0x4, A=10; A<=30; Ga++, A+=2) {
    for (Gb=0; Gb<8; Gb++) {
      B = 16 << Gb;
//      if (B <= 3*C)
//	continue; /* Condition 2, at least require positiv Tr */
      divisor = B * (A + ((3*C)/B)*2);
      if (divisor > req_div && divisor < est_div) {
	est_div = divisor;
	bin_Gb = Gb << 2;
	bin_Ga = (Ga & 0x3) | ((Ga & 0x4) << 3);
	est_FDR = bin_Gb | bin_Ga;
	est_A = A;
	est_B = B;
	//printf("bin_Gb:0x%x, bin_Ga:0x%x\n", bin_Gb, bin_Ga);
	printf("FDR:0x%.2x, div:%d, Ga:0x%x, Gb:0x%x, A:%d, B:%d, speed:%d\n",
	       est_FDR, est_div, Ga, Gb, A, B, I2C_CLK/est_div);
	//printf("speed:%d\n", I2C_CLK/est_div);
#if 0
/* Condition 2 not accounted for */
	{
	  unsigned long T = 1000000000/I2C_CLK;

	  printf("Tr <= %d ns\n", (B-3*C)* 1000000/(I2C_CLK/1000));
	}
#endif
	putchar('\n');
      }
    }
#if 1
/* The old table in u-boot miss this, I think */
    if (A == 20)
      A+=2;
    if (A == 24)
      A+=4;
#endif
  }

#if 1
  printf("********************* Result ****************\n");
  printf("req_div:%d, est_div:%d, DFSR:%d\n", req_div, est_div, C);
  printf("FDR:0x%.2x\n", est_FDR);
  printf("speed:%d\n", I2C_CLK/est_div);
  printf("Tr <= %d ns\n", (est_B-3*C)* 1000000/(I2C_CLK/1000));
#endif
}
